# ba_tester_with_custom_parameters
#
# This file was automatically generated by APIMATIC v2.0
# ( https://apimatic.io ).

module BaTesterWithCustomParameters
  # An enum for SDK environments.
  class Environment
    ENVIRONMENT = [
      PRODUCTION = 'production'.freeze,
      TESTING = 'testing'.freeze
    ].freeze
  end

  # An enum for API servers.
  class Server
    SERVER = [
      DEFAULT = 'default'.freeze,
      AUTH_SERVER = 'auth server'.freeze
    ].freeze
  end

  # All configuration including auth info and base URI for the API access
  # are configured in this class.
  class Configuration
    # The attribute readers for properties.
    attr_reader :http_client
    attr_reader :timeout
    attr_reader :max_retries
    attr_reader :retry_interval
    attr_reader :backoff_factor
    attr_reader :environment
    attr_reader :port
    attr_reader :suites
    attr_reader :username
    attr_reader :password

    class << self
      attr_reader :environments
    end

    def initialize(timeout: 60, max_retries: 0, retry_interval: 1,
                   backoff_factor: 1, environment: Environment::TESTING,
                   port: '80', suites: SuiteCodeEnum::HEARTS,
                   username: 'farhan', password: 'apimatic')
      # The value to use for connection timeout
      @timeout = timeout

      # The number of times to retry an endpoint call if it fails
      @max_retries = max_retries

      # Pause in seconds between retries
      @retry_interval = retry_interval

      # The amount to multiply each successive retry's interval amount
      # by in order to provide backoff
      @backoff_factor = backoff_factor

      # Current API environment
      @environment = String(environment)

      # port value
      @port = port

      # suites value
      @suites = suites

      # TODO: Replace
      @username = username

      # TODO: Replace
      @password = password

      # The Http Client to use for making requests.
      @http_client = create_http_client
    end

    def clone_with(timeout: nil, max_retries: nil, retry_interval: nil,
                   backoff_factor: nil, environment: nil, port: nil,
                   suites: nil, username: nil, password: nil)
      timeout ||= self.timeout
      max_retries ||= self.max_retries
      retry_interval ||= self.retry_interval
      backoff_factor ||= self.backoff_factor
      environment ||= self.environment
      port ||= self.port
      suites ||= self.suites
      username ||= self.username
      password ||= self.password

      Configuration.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor,
                        environment: environment, port: port, suites: suites,
                        username: username, password: password)
    end

    def create_http_client
      FaradayClient.new(timeout: timeout, max_retries: max_retries,
                        retry_interval: retry_interval,
                        backoff_factor: backoff_factor)
    end

    # All the environments the SDK can run in.
    ENVIRONMENTS = {
      Environment::PRODUCTION => {
        Server::DEFAULT => 'http://apimatic.hopto.org:{suites}',
        Server::AUTH_SERVER => 'http://apimaticauth.hopto.org:3000'
      },
      Environment::TESTING => {
        Server::DEFAULT => 'http://localhost:3000',
        Server::AUTH_SERVER => 'http://apimaticauth.xhopto.org:3000'
      }
    }.freeze

    # Generates the appropriate base URI for the environment and the server.
    # @param [Configuration::Server] The server enum for which the base URI is
    # required.
    # @return [String] The base URI.
    def get_base_uri(server = Server::DEFAULT)
      parameters = {
        'port' => { 'value' => port, 'encode' => false },
        'suites' => { 'value' => suites, 'encode' => false }
      }
      APIHelper.append_url_with_template_parameters(
        ENVIRONMENTS[environment][server], parameters
      )
    end
  end
end
